Index: /LMDZ5/branches/testing/libf/phylmd/aaam_bud.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/aaam_bud.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/aaam_bud.F90	(revision 2408)
@@ -6,4 +6,5 @@
 
   USE dimphy
+  USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat, klon_glo
   IMPLICIT NONE
   ! ======================================================================
@@ -58,8 +59,8 @@
   ! ===================
 
-  ! iim--common-I: Number of longitude intervals
-  ! jjm--common-I: Number of latitude intervals
+  ! nbp_lon--common-I: Number of longitude intervals
+  ! (nbp_lat-1)--common-I: Number of latitude intervals
   ! klon-common-I: Number of points seen by the physics
-  ! iim*(jjm-1)+2 for instance
+  ! nbp_lon*(nbp_lat-2)+2 for instance
   ! klev-common-I: Number of vertical layers
   ! ======================================================================
@@ -84,7 +85,4 @@
   ! ======================================================================
 
-  include "dimensions.h"
-  ! cc#include "dimphy.h"
-
   ! ARGUMENTS
 
@@ -121,7 +119,7 @@
   ! PUT AAM QUANTITIES AT ZERO:
 
-  IF (iim+1>801 .OR. jjm+1>401) THEN
+  IF (nbp_lon+1>801 .OR. nbp_lat>401) THEN
     abort_message = 'Pb de dimension dans aaam_bud'
-    CALL abort_gcm(modname, abort_message, 1)
+    CALL abort_physic(modname, abort_message, 1)
   END IF
 
@@ -129,6 +127,10 @@
   hadley = 1.E18
   hadday = 1.E18*24.*3600.
-  dlat = xpi/real(jjm)
-  dlon = 2.*xpi/real(iim)
+  IF(klon_glo.EQ.1) THEN
+    dlat = xpi
+  ELSE
+    dlat = xpi/real(nbp_lat-1)
+  ENDIF
+  dlon = 2.*xpi/real(nbp_lon)
 
   DO iax = 1, 3
@@ -155,5 +157,5 @@
   zlat(1) = plat(l)*xpi/180.
 
-  DO i = 1, iim + 1
+  DO i = 1, nbp_lon + 1
 
     zs(i, 1) = phis(l)/rg
@@ -169,26 +171,26 @@
 
 
-  DO j = 2, jjm
+  DO j = 2, nbp_lat-1
 
     ! Values at Greenwich (Periodicity)
 
-    zs(iim+1, j) = phis(l+1)/rg
-    ps(iim+1, j) = p(l+1, 1)
-    ssou(iim+1, j) = dragu(l+1) + liftu(l+1)
-    ssov(iim+1, j) = dragv(l+1) + liftv(l+1)
-    blsu(iim+1, j) = phyu(l+1) - dragu(l+1) - liftu(l+1)
-    blsv(iim+1, j) = phyv(l+1) - dragv(l+1) - liftv(l+1)
-    zlon(iim+1) = -plon(l+1)*xpi/180.
+    zs(nbp_lon+1, j) = phis(l+1)/rg
+    ps(nbp_lon+1, j) = p(l+1, 1)
+    ssou(nbp_lon+1, j) = dragu(l+1) + liftu(l+1)
+    ssov(nbp_lon+1, j) = dragv(l+1) + liftv(l+1)
+    blsu(nbp_lon+1, j) = phyu(l+1) - dragu(l+1) - liftu(l+1)
+    blsv(nbp_lon+1, j) = phyv(l+1) - dragv(l+1) - liftv(l+1)
+    zlon(nbp_lon+1) = -plon(l+1)*xpi/180.
     zlat(j) = plat(l+1)*xpi/180.
 
-    ub(iim+1, j) = 0.
-    vb(iim+1, j) = 0.
+    ub(nbp_lon+1, j) = 0.
+    vb(nbp_lon+1, j) = 0.
     DO k = 1, nlev
-      ub(iim+1, j) = ub(iim+1, j) + u(l+1, k)*(p(l+1,k)-p(l+1,k+1))/rg
-      vb(iim+1, j) = vb(iim+1, j) + v(l+1, k)*(p(l+1,k)-p(l+1,k+1))/rg
-    END DO
-
-
-    DO i = 1, iim
+      ub(nbp_lon+1, j) = ub(nbp_lon+1, j) + u(l+1, k)*(p(l+1,k)-p(l+1,k+1))/rg
+      vb(nbp_lon+1, j) = vb(nbp_lon+1, j) + v(l+1, k)*(p(l+1,k)-p(l+1,k+1))/rg
+    END DO
+
+
+    DO i = 1, nbp_lon
 
       l = l + 1
@@ -215,23 +217,23 @@
   ! South Pole
 
-  IF (jjm>1) THEN
+  IF (nbp_lat-1>1) THEN
     l = l + 1
-    ub(1, jjm+1) = 0.
-    vb(1, jjm+1) = 0.
+    ub(1, nbp_lat) = 0.
+    vb(1, nbp_lat) = 0.
     DO k = 1, nlev
-      ub(1, jjm+1) = ub(1, jjm+1) + u(l, k)*(p(l,k)-p(l,k+1))/rg
-      vb(1, jjm+1) = vb(1, jjm+1) + v(l, k)*(p(l,k)-p(l,k+1))/rg
-    END DO
-    zlat(jjm+1) = plat(l)*xpi/180.
-
-    DO i = 1, iim + 1
-      zs(i, jjm+1) = phis(l)/rg
-      ps(i, jjm+1) = p(l, 1)
-      ssou(i, jjm+1) = dragu(l) + liftu(l)
-      ssov(i, jjm+1) = dragv(l) + liftv(l)
-      blsu(i, jjm+1) = phyu(l) - dragu(l) - liftu(l)
-      blsv(i, jjm+1) = phyv(l) - dragv(l) - liftv(l)
-      ub(i, jjm+1) = ub(1, jjm+1)
-      vb(i, jjm+1) = vb(1, jjm+1)
+      ub(1, nbp_lat) = ub(1, nbp_lat) + u(l, k)*(p(l,k)-p(l,k+1))/rg
+      vb(1, nbp_lat) = vb(1, nbp_lat) + v(l, k)*(p(l,k)-p(l,k+1))/rg
+    END DO
+    zlat(nbp_lat) = plat(l)*xpi/180.
+
+    DO i = 1, nbp_lon + 1
+      zs(i, nbp_lat) = phis(l)/rg
+      ps(i, nbp_lat) = p(l, 1)
+      ssou(i, nbp_lat) = dragu(l) + liftu(l)
+      ssov(i, nbp_lat) = dragv(l) + liftv(l)
+      blsu(i, nbp_lat) = phyu(l) - dragu(l) - liftu(l)
+      blsv(i, nbp_lat) = phyv(l) - dragv(l) - liftv(l)
+      ub(i, nbp_lat) = ub(1, nbp_lat)
+      vb(i, nbp_lat) = vb(1, nbp_lat)
     END DO
   END IF
@@ -240,6 +242,6 @@
   ! MOMENT ANGULAIRE
 
-  DO j = 1, jjm
-    DO i = 1, iim
+  DO j = 1, nbp_lat-1
+    DO i = 1, nbp_lon
 
       raam(1) = raam(1) - rea**3*dlon*dlat*0.5*(cos(zlon(i))*sin(zlat(j))*cos &
@@ -274,6 +276,6 @@
 
 
-  DO j = 1, jjm
-    DO i = 1, iim
+  DO j = 1, nbp_lat-1
+    DO i = 1, nbp_lon
       tmou(1) = tmou(1) - rea**2*dlon*0.5*sin(zlon(i))*(zs(i,j)-zs(i,j+1))*( &
         cos(zlat(j+1))*ps(i,j+1)+cos(zlat(j))*ps(i,j))
@@ -283,6 +285,6 @@
   END DO
 
-  DO j = 2, jjm
-    DO i = 1, iim
+  DO j = 2, nbp_lat-1
+    DO i = 1, nbp_lon
       tmou(1) = tmou(1) + rea**2*dlat*0.5*sin(zlat(j))*(zs(i+1,j)-zs(i,j))*( &
         cos(zlon(i+1))*ps(i+1,j)+cos(zlon(i))*ps(i,j))
@@ -298,6 +300,6 @@
 
   l = 1
-  DO j = 2, jjm
-    DO i = 1, iim
+  DO j = 2, nbp_lat-1
+    DO i = 1, nbp_lon
       l = l + 1
       tsso(1) = tsso(1) - rea**3*cos(zlat(j))*dlon*dlat*ssou(i, j)*sin(zlat(j &
@@ -341,12 +343,12 @@
 100 FORMAT (F12.5, 15(1X,F12.5))
 
-  ! write(iam+1,*)((zs(i,j),i=1,iim),j=1,jjm+1)
-  ! write(iam+1,*)((ps(i,j),i=1,iim),j=1,jjm+1)
-  ! write(iam+1,*)((ub(i,j),i=1,iim),j=1,jjm+1)
-  ! write(iam+1,*)((vb(i,j),i=1,iim),j=1,jjm+1)
-  ! write(iam+1,*)((ssou(i,j),i=1,iim),j=1,jjm+1)
-  ! write(iam+1,*)((ssov(i,j),i=1,iim),j=1,jjm+1)
-  ! write(iam+1,*)((blsu(i,j),i=1,iim),j=1,jjm+1)
-  ! write(iam+1,*)((blsv(i,j),i=1,iim),j=1,jjm+1)
+  ! write(iam+1,*)((zs(i,j),i=1,nbp_lon),j=1,nbp_lat)
+  ! write(iam+1,*)((ps(i,j),i=1,nbp_lon),j=1,nbp_lat)
+  ! write(iam+1,*)((ub(i,j),i=1,nbp_lon),j=1,nbp_lat)
+  ! write(iam+1,*)((vb(i,j),i=1,nbp_lon),j=1,nbp_lat)
+  ! write(iam+1,*)((ssou(i,j),i=1,nbp_lon),j=1,nbp_lat)
+  ! write(iam+1,*)((ssov(i,j),i=1,nbp_lon),j=1,nbp_lat)
+  ! write(iam+1,*)((blsu(i,j),i=1,nbp_lon),j=1,nbp_lat)
+  ! write(iam+1,*)((blsv(i,j),i=1,nbp_lon),j=1,nbp_lat)
 
   aam = raam(3)
Index: /LMDZ5/branches/testing/libf/phylmd/acama_gwd_rando_m.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/acama_gwd_rando_m.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/phylmd/acama_gwd_rando_m.F90	(revision 2408)
@@ -0,0 +1,493 @@
+module ACAMA_GWD_rando_m
+
+  implicit none
+
+contains
+
+  SUBROUTINE ACAMA_GWD_rando(DTIME, pp, plat, tt, uu, vv, rot, &
+       zustr, zvstr, d_u, d_v,east_gwstress,west_gwstress)
+
+    ! Parametrization of the momentum flux deposition due to a discrete
+    ! number of gravity waves. 
+    ! Author: F. Lott, A. de la Camara
+    ! July, 24th, 2014
+    ! Gaussian distribution of the source, source is vorticity squared
+    ! Reference: de la Camara and Lott (GRL, 2015, vol 42, 2071-2078 )
+    ! Lott et al (JAS, 2010, vol 67, page 157-170)
+    ! Lott et al (JAS, 2012, vol 69, page 2134-2151)
+
+!  ONLINE:
+    use dimphy, only: klon, klev
+    use assert_m, only: assert
+    include "YOMCST.h"
+    include "clesphys.h"
+!  OFFLINE:
+!   include "dimensions.h"
+!   include "dimphy.h"
+!END DIFFERENCE
+    include "YOEGWD.h"
+
+    ! 0. DECLARATIONS:
+
+    ! 0.1 INPUTS
+    REAL, intent(in)::DTIME ! Time step of the Physics
+    REAL, intent(in):: PP(:, :) ! (KLON, KLEV) Pressure at full levels
+    REAL, intent(in):: ROT(:,:) ! Relative vorticity              
+    REAL, intent(in):: TT(:, :) ! (KLON, KLEV) Temp at full levels 
+    REAL, intent(in):: UU(:, :) ! (KLON, KLEV) Zonal wind at full levels
+    REAL, intent(in):: VV(:, :) ! (KLON, KLEV) Merid wind at full levels
+    REAL, intent(in):: PLAT(:) ! (KLON) LATITUDE                   
+
+    ! 0.2 OUTPUTS
+    REAL, intent(out):: zustr(:), zvstr(:) ! (KLON) Surface Stresses
+
+    REAL, intent(inout):: d_u(:, :), d_v(:, :) 
+    REAL, intent(inout):: east_gwstress(:, :) !  Profile of eastward stress
+    REAL, intent(inout):: west_gwstress(:, :) !  Profile of westward stress 
+    ! (KLON, KLEV) tendencies on winds
+
+    ! O.3 INTERNAL ARRAYS
+    REAL BVLOW(klon)  !  LOW LEVEL BV FREQUENCY
+    REAL ROTBA(KLON),CORIO(KLON)  !  BAROTROPIC REL. VORTICITY AND PLANETARY
+    REAL UZ(KLON, KLEV + 1)
+
+    INTEGER II, JJ, LL
+
+    ! 0.3.0 TIME SCALE OF THE LIFE CYCLE OF THE WAVES PARAMETERIZED
+
+    REAL DELTAT
+
+    ! 0.3.1 GRAVITY-WAVES SPECIFICATIONS
+
+    INTEGER, PARAMETER:: NK = 2, NP = 2, NO = 2, NW = NK * NP * NO
+    INTEGER JK, JP, JO, JW
+    INTEGER, PARAMETER:: NA = 5  !number of realizations to get the phase speed
+    REAL KMIN, KMAX ! Min and Max horizontal wavenumbers
+    REAL CMIN, CMAX ! Min and Max absolute ph. vel.
+    REAL CPHA ! absolute PHASE VELOCITY frequency
+    REAL ZK(NW, KLON) ! Horizontal wavenumber amplitude
+    REAL ZP(NW, KLON) ! Horizontal wavenumber angle 
+    REAL ZO(NW, KLON) ! Absolute frequency !
+
+    ! Waves Intr. freq. at the 1/2 lev surrounding the full level
+    REAL ZOM(NW, KLON), ZOP(NW, KLON)
+
+    ! Wave EP-fluxes at the 2 semi levels surrounding the full level
+    REAL WWM(NW, KLON), WWP(NW, KLON)
+
+    REAL RUW0(NW, KLON) ! Fluxes at launching level
+
+    REAL RUWP(NW, KLON), RVWP(NW, KLON)
+    ! Fluxes X and Y for each waves at 1/2 Levels
+
+    INTEGER LAUNCH, LTROP ! Launching altitude and tropo altitude
+
+    REAL XLAUNCH ! Controle the launching altitude
+    REAL XTROP ! SORT of Tropopause altitude 
+    REAL RUW(KLON, KLEV + 1) ! Flux x at semi levels
+    REAL RVW(KLON, KLEV + 1) ! Flux y at semi levels
+
+    REAL PRMAX ! Maximum value of PREC, and for which our linear formula
+    ! for GWs parameterisation apply
+
+    ! 0.3.2 PARAMETERS OF WAVES DISSIPATIONS
+
+    REAL RDISS, ZOISEC ! COEFF DE DISSIPATION, SECURITY FOR INTRINSIC FREQ
+    REAL CORSEC ! SECURITY FOR INTRINSIC CORIOLIS
+    REAL RUWFRT,SATFRT
+
+    ! 0.3.3 BACKGROUND FLOW AT 1/2 LEVELS AND VERTICAL COORDINATE
+
+    REAL H0 ! Characteristic Height of the atmosphere
+    REAL DZ ! Characteristic depth of the source!
+    REAL PR, TR ! Reference Pressure and Temperature
+
+    REAL ZH(KLON, KLEV + 1) ! Log-pressure altitude
+
+    REAL UH(KLON, KLEV + 1), VH(KLON, KLEV + 1) ! Winds at 1/2 levels
+    REAL PH(KLON, KLEV + 1) ! Pressure at 1/2 levels
+    REAL PSEC ! Security to avoid division by 0 pressure
+    REAL PHM1(KLON, KLEV + 1) ! 1/Press at 1/2 levels
+    REAL BV(KLON, KLEV + 1) ! Brunt Vaisala freq. (BVF) at 1/2 levels
+    REAL BVSEC ! Security to avoid negative BVF
+
+    !-----------------------------------------------------------------
+
+    ! 1. INITIALISATIONS
+
+    ! 1.1 Basic parameter
+
+    ! Are provided from elsewhere (latent heat of vaporization, dry
+    ! gaz constant for air, gravity constant, heat capacity of dry air
+    ! at constant pressure, earth rotation rate, pi).
+
+    ! 1.2 Tuning parameters of V14
+
+! Values for linear in rot (recommended):
+!   RUWFRT=0.005 ! As RUWMAX but for frontal waves 
+!   SATFRT=1.00  ! As SAT    but for frontal waves
+! Values when rot^2 is used                          
+!    RUWFRT=0.02  ! As RUWMAX but for frontal waves 
+!    SATFRT=1.00  ! As SAT    but for frontal waves
+!    CMAX = 30.   ! Characteristic phase speed
+! Values when rot^2*EXP(-pi*sqrt(J)) is used                          
+!   RUWFRT=2.5   ! As RUWMAX but for frontal waves ~ N0*F0/4*DZ
+!   SATFRT=0.60   ! As SAT    but for frontal waves
+    RUWFRT=gwd_front_ruwmax  
+    SATFRT=gwd_front_sat
+    CMAX = 40.    ! Characteristic phase speed
+! Phase speed test
+!   RUWFRT=0.01
+!   CMAX = 50.   ! Characteristic phase speed (TEST)
+! Values when rot^2 and exp(-m^2*dz^2) are used      
+!   RUWFRT=0.03  ! As RUWMAX but for frontal waves 
+!   SATFRT=1.00  ! As SAT    but for frontal waves
+! CRUCIAL PARAMETERS FOR THE WIND FILTERING
+    XLAUNCH=0.95 ! Parameter that control launching altitude
+    RDISS = 1    ! Diffusion parameter 
+
+    ! maximum of rain for which our theory applies (in kg/m^2/s)
+
+    DZ = 1000. ! Characteristic depth of the source
+    XTROP=0.2 ! Parameter that control tropopause altitude
+    DELTAT=24.*3600. ! Time scale of the waves (first introduced in 9b)
+!   DELTAT=DTIME     ! No AR-1 Accumulation, OR OFFLINE             
+
+    KMIN = 2.E-5
+    ! minimum horizontal wavenumber (inverse of the subgrid scale resolution)
+
+    KMAX = 1.E-3  ! Max horizontal wavenumber
+    CMIN = 1.     ! Min phase velocity
+
+    TR = 240. ! Reference Temperature
+    PR = 101300. ! Reference pressure
+    H0 = RD * TR / RG ! Characteristic vertical scale height
+
+    BVSEC = 5.E-3 ! Security to avoid negative BVF 
+    PSEC = 1.E-6 ! Security to avoid division by 0 pressure
+    ZOISEC = 1.E-6 ! Security FOR 0 INTRINSIC FREQ
+    CORSEC = ROMEGA*2.*SIN(2.*RPI/180.)! Security for CORIO
+
+!  ONLINE
+    call assert(klon == (/size(pp, 1), size(tt, 1), size(uu, 1), &
+         size(vv, 1), size(rot,1), size(zustr), size(zvstr), size(d_u, 1), &
+         size(d_v, 1), &
+        size(east_gwstress,1), size(west_gwstress,1) /), &
+        "ACAMA_GWD_RANDO klon")
+    call assert(klev == (/size(pp, 2), size(tt, 2), size(uu, 2), &
+         size(vv, 2), size(d_u, 2), size(d_v, 2), &
+         size(east_gwstress,2), size(west_gwstress,2) /), &
+         "ACAMA_GWD_RANDO klev")
+!  END ONLINE
+
+    IF(DELTAT < DTIME)THEN
+       PRINT *, 'flott_gwd_rando: deltat < dtime!'
+       STOP 1
+    ENDIF
+
+    IF (KLEV < NW) THEN
+       PRINT *, 'flott_gwd_rando: you will have problem with random numbers'
+       STOP 1
+    ENDIF
+
+    ! 2. EVALUATION OF THE BACKGROUND FLOW AT SEMI-LEVELS
+
+    ! Pressure and Inv of pressure
+    DO LL = 2, KLEV
+       PH(:, LL) = EXP((LOG(PP(:, LL)) + LOG(PP(:, LL - 1))) / 2.)
+       PHM1(:, LL) = 1. / PH(:, LL) 
+    end DO
+
+    PH(:, KLEV + 1) = 0. 
+    PHM1(:, KLEV + 1) = 1. / PSEC
+    PH(:, 1) = 2. * PP(:, 1) - PH(:, 2)
+
+    ! Launching altitude
+
+    LAUNCH=0
+    LTROP =0
+    DO LL = 1, KLEV
+       IF (PH(KLON / 2, LL) / PH(KLON / 2, 1) > XLAUNCH) LAUNCH = LL
+    ENDDO
+    DO LL = 1, KLEV
+       IF (PH(KLON / 2, LL) / PH(KLON / 2, 1) > XTROP) LTROP = LL
+    ENDDO
+
+!   PRINT *,'LAUNCH IN ACAMARA:',LAUNCH
+
+    ! Log pressure vert. coordinate
+    DO LL = 1, KLEV + 1 
+       ZH(:, LL) = H0 * LOG(PR / (PH(:, LL) + PSEC))
+    end DO
+
+    ! BV frequency
+    DO LL = 2, KLEV
+       ! BVSEC: BV Frequency (UH USED IS AS A TEMPORARY ARRAY DOWN TO WINDS)
+       UH(:, LL) = 0.5 * (TT(:, LL) + TT(:, LL - 1)) &
+            * RD**2 / RCPD / H0**2 + (TT(:, LL) &
+            - TT(:, LL - 1)) / (ZH(:, LL) - ZH(:, LL - 1)) * RD / H0
+    end DO
+    BVLOW = 0.5 * (TT(:, LTROP )+ TT(:, LAUNCH)) &
+         * RD**2 / RCPD / H0**2 + (TT(:, LTROP ) &
+         - TT(:, LAUNCH))/(ZH(:, LTROP )- ZH(:, LAUNCH)) * RD / H0
+
+    UH(:, 1) = UH(:, 2)
+    UH(:, KLEV + 1) = UH(:, KLEV)
+    BV(:, 1) = UH(:, 2)
+    BV(:, KLEV + 1) = UH(:, KLEV)
+    ! SMOOTHING THE BV HELPS
+    DO LL = 2, KLEV
+       BV(:, LL)=(UH(:, LL+1)+2.*UH(:, LL)+UH(:, LL-1))/4.
+    end DO
+
+    BV=MAX(SQRT(MAX(BV, 0.)), BVSEC)
+    BVLOW=MAX(SQRT(MAX(BVLOW, 0.)), BVSEC)
+
+    ! WINDS
+    DO LL = 2, KLEV
+       UH(:, LL) = 0.5 * (UU(:, LL) + UU(:, LL - 1)) ! Zonal wind
+       VH(:, LL) = 0.5 * (VV(:, LL) + VV(:, LL - 1)) ! Meridional wind
+       UZ(:, LL) = ABS((SQRT(UU(:, LL)**2+VV(:, LL)**2) & 
+          - SQRT(UU(:,LL-1)**2+VV(:, LL-1)**2)) &
+          /(ZH(:, LL)-ZH(:, LL-1)) )
+    end DO
+    UH(:, 1) = 0.
+    VH(:, 1) = 0.
+    UH(:, KLEV + 1) = UU(:, KLEV)
+    VH(:, KLEV + 1) = VV(:, KLEV)
+
+    UZ(:, 1) = UZ(:, 2)
+    UZ(:, KLEV + 1) = UZ(:, KLEV)
+    UZ(:, :) = MAX(UZ(:,:), PSEC)
+
+   ! BAROTROPIC VORTICITY AND INTEGRATED CORIOLIS PARAMETER
+    
+    CORIO(:) = MAX(ROMEGA*2.*ABS(SIN(PLAT(:)*RPI/180.)),CORSEC)
+    ROTBA(:)=0.
+    DO LL = 1,KLEV-1
+        !ROTBA(:) = ROTBA(:) + (ROT(:,LL)+ROT(:,LL+1))/2./RG*(PP(:,LL)-PP(:,LL+1))
+        ! Introducing the complete formula (exp of Richardson number):
+        ROTBA(:) = ROTBA(:) + &
+                !((ROT(:,LL)+ROT(:,LL+1))/2.)**2 &
+                (CORIO(:)*TANH(ABS(ROT(:,LL)+ROT(:,LL+1))/2./CORIO(:)))**2 &
+                /RG*(PP(:,LL)-PP(:,LL+1)) &
+                * EXP(-RPI*BV(:,LL+1)/UZ(:,LL+1)) &
+!               * DZ*BV(:,LL+1)/4./ABS(CORIO(:)) 
+                * DZ*BV(:,LL+1)/4./1.E-4           !  Changes after 1991
+!ARRET
+    ENDDO
+    !   PRINT *,'MAX ROTBA:',MAXVAL(ROTBA)
+    !   ROTBA(:)=(1.*ROTBA(:)  & ! Testing zone
+    !           +0.15*CORIO(:)**2                &
+    !           /(COS(PLAT(:)*RPI/180.)+0.02)  &
+    !           )*DZ*0.01/0.0001/4. ! & ! Testing zone
+    !   MODIF GWD4 AFTER 1985
+    !            *(1.25+SIN(PLAT(:)*RPI/180.))/(1.05+SIN(PLAT(:)*RPI/180.))/1.25
+    !          *1./(COS(PLAT(:)*RPI/180.)+0.02)
+    !    CORIO(:) = MAX(ROMEGA*2.*ABS(SIN(PLAT(:)*RPI/180.)),ZOISEC)/RG*PP(:,1)
+
+    ! 3 WAVES CHARACTERISTICS CHOSEN RANDOMLY AT THE LAUNCH ALTITUDE
+
+    ! The mod functions of weird arguments are used to produce the
+    ! waves characteristics in an almost stochastic way
+
+    JW = 0
+    DO JP = 1, NP
+       DO JK = 1, NK
+          DO JO = 1, NO
+             JW = JW + 1
+             ! Angle
+             DO II = 1, KLON
+                ! Angle (0 or PI so far)
+                ! ZP(JW, II) = (SIGN(1., 0.5 - MOD(TT(II, JW) * 10., 1.)) + 1.) &
+                !      * RPI / 2.
+                ! Angle between 0 and pi
+                  ZP(JW, II) = MOD(TT(II, JW) * 10., 1.) * RPI
+! TEST WITH POSITIVE WAVES ONLY (Part I/II)
+!               ZP(JW, II) = 0.
+                ! Horizontal wavenumber amplitude
+                ZK(JW, II) = KMIN + (KMAX - KMIN) * MOD(TT(II, JW) * 100., 1.)
+                ! Horizontal phase speed
+                CPHA = 0.
+                DO JJ = 1, NA
+                    CPHA = CPHA + &
+         CMAX*2.*(MOD(TT(II, JW+4*(JJ-1)+JJ)**2, 1.)-0.5)*SQRT(3.)/SQRT(NA*1.)
+                END DO
+                IF (CPHA.LT.0.)  THEN
+                   CPHA = -1.*CPHA
+                   ZP(JW,II) = ZP(JW,II) + RPI
+! TEST WITH POSITIVE WAVES ONLY (Part II/II)
+!               ZP(JW, II) = 0.
+                ENDIF
+                CPHA = CPHA + CMIN !we dont allow |c|<1m/s
+                ! Absolute frequency is imposed
+                ZO(JW, II) = CPHA * ZK(JW, II) 
+                ! Intrinsic frequency is imposed
+                ZO(JW, II) = ZO(JW, II) &
+                     + ZK(JW, II) * COS(ZP(JW, II)) * UH(II, LAUNCH) &
+                     + ZK(JW, II) * SIN(ZP(JW, II)) * VH(II, LAUNCH)
+                ! Momentum flux at launch lev 
+                ! LAUNCHED RANDOM WAVES WITH LOG-NORMAL AMPLITUDE
+                !  RIGHT IN THE SH (GWD4 after 1990)
+                  RUW0(JW, II) = 0.
+                 DO JJ = 1, NA
+                    RUW0(JW, II) = RUW0(JW,II) + &
+         2.*(MOD(TT(II, JW+4*(JJ-1)+JJ)**2, 1.)-0.5)*SQRT(3.)/SQRT(NA*1.)
+                END DO
+                RUW0(JW, II) = RUWFRT &
+                          * EXP(RUW0(JW,II))/1250. &  ! 2 mpa at south pole
+       *((1.05+SIN(PLAT(II)*RPI/180.))/(1.01+SIN(PLAT(II)*RPI/180.))-2.05/2.01)
+                ! RUW0(JW, II) = RUWFRT
+             ENDDO
+          end DO
+       end DO
+    end DO
+
+    ! 4. COMPUTE THE FLUXES
+
+    ! 4.0 
+
+    ! 4.1 Vertical velocity at launching altitude to ensure 
+    ! the correct value to the imposed fluxes.
+
+    DO JW = 1, NW
+
+       ! Evaluate intrinsic frequency at launching altitude:
+       ZOP(JW, :) = ZO(JW, :) &
+            - ZK(JW, :) * COS(ZP(JW, :)) * UH(:, LAUNCH) &
+            - ZK(JW, :) * SIN(ZP(JW, :)) * VH(:, LAUNCH) 
+
+       ! VERSION WITH FRONTAL SOURCES
+
+       ! Momentum flux at launch level imposed by vorticity sources
+
+       ! tanh limitation for values above CORIO (inertial instability).
+       ! WWP(JW, :) = RUW0(JW, :) &
+       WWP(JW, :) = RUWFRT      &
+       !     * (CORIO(:)*TANH(ROTBA(:)/CORIO(:)))**2 &
+       !    * ABS((CORIO(:)*TANH(ROTBA(:)/CORIO(:)))*CORIO(:)) &
+       !  CONSTANT FLUX
+       !    * (CORIO(:)*CORIO(:)) &
+       ! MODERATION BY THE DEPTH OF THE SOURCE (DZ HERE)
+       !      *EXP(-BVLOW(:)**2/MAX(ABS(ZOP(JW, :)),ZOISEC)**2 &
+       !      *ZK(JW, :)**2*DZ**2) &
+       ! COMPLETE FORMULA:
+            !* CORIO(:)**2*TANH(ROTBA(:)/CORIO(:)**2) &
+            * ROTBA(:) &
+       !  RESTORE DIMENSION OF A FLUX
+       !     *RD*TR/PR
+             *1. + RUW0(JW, :)
+
+       ! Factor related to the characteristics of the waves: NONE
+
+       ! Moderation by the depth of the source (dz here): NONE
+
+       ! Put the stress in the right direction:
+
+        RUWP(JW, :) = SIGN(1., ZOP(JW, :))*COS(ZP(JW, :)) * WWP(JW, :)
+        RVWP(JW, :) = SIGN(1., ZOP(JW, :))*SIN(ZP(JW, :)) * WWP(JW, :)
+
+    end DO
+
+    ! 4.2 Uniform values below the launching altitude
+
+    DO LL = 1, LAUNCH
+       RUW(:, LL) = 0
+       RVW(:, LL) = 0
+       DO JW = 1, NW
+          RUW(:, LL) = RUW(:, LL) + RUWP(JW, :)
+          RVW(:, LL) = RVW(:, LL) + RVWP(JW, :)
+       end DO
+    end DO
+
+    ! 4.3 Loop over altitudes, with passage from one level to the next
+    ! done by i) conserving the EP flux, ii) dissipating a little,
+    ! iii) testing critical levels, and vi) testing the breaking.
+
+    DO LL = LAUNCH, KLEV - 1
+       ! Warning: all the physics is here (passage from one level
+       ! to the next)
+       DO JW = 1, NW
+          ZOM(JW, :) = ZOP(JW, :)
+          WWM(JW, :) = WWP(JW, :)
+          ! Intrinsic Frequency
+          ZOP(JW, :) = ZO(JW, :) - ZK(JW, :) * COS(ZP(JW, :)) * UH(:, LL + 1) &
+               - ZK(JW, :) * SIN(ZP(JW, :)) * VH(:, LL + 1) 
+
+          ! No breaking (Eq.6)
+          ! Dissipation (Eq. 8)
+          WWP(JW, :) = WWM(JW, :) * EXP(- 2. * RDISS * PR / (PH(:, LL + 1) &
+               + PH(:, LL)) * ((BV(:, LL + 1) + BV(:, LL)) / 2.)**3 &
+               / MAX(ABS(ZOP(JW, :) + ZOM(JW, :)) / 2., ZOISEC)**4 &
+               * ZK(JW, :)**3 * (ZH(:, LL + 1) - ZH(:, LL)))
+
+          ! Critical levels (forced to zero if intrinsic frequency changes sign)
+          ! Saturation (Eq. 12)
+          WWP(JW, :) = min(WWP(JW, :), MAX(0., &
+               SIGN(1., ZOP(JW, :) * ZOM(JW, :))) * ABS(ZOP(JW, :))**3 &
+          !    / BV(:, LL + 1) * EXP(- ZH(:, LL + 1) / H0) * SATFRT**2 * KMIN**2 &
+               / BV(:, LL + 1) * EXP(- ZH(:, LL + 1) / H0) * KMIN**2 &
+!              *(SATFRT*(2.5+1.5*TANH((ZH(:,LL+1)/H0-8.)/2.)))**2 &
+               *SATFRT**2       &
+               / ZK(JW, :)**4)
+       end DO
+
+       ! Evaluate EP-flux from Eq. 7 and give the right orientation to
+       ! the stress
+
+       DO JW = 1, NW
+          RUWP(JW, :) = SIGN(1., ZOP(JW, :))*COS(ZP(JW, :)) * WWP(JW, :)
+          RVWP(JW, :) = SIGN(1., ZOP(JW, :))*SIN(ZP(JW, :)) * WWP(JW, :)
+       end DO
+
+       RUW(:, LL + 1) = 0.
+       RVW(:, LL + 1) = 0.
+
+       DO JW = 1, NW
+          RUW(:, LL + 1) = RUW(:, LL + 1) + RUWP(JW, :) 
+          RVW(:, LL + 1) = RVW(:, LL + 1) + RVWP(JW, :) 
+          EAST_GWSTRESS(:, LL)=EAST_GWSTRESS(:, LL)+MAX(0.,RUWP(JW,:))/FLOAT(NW)
+          WEST_GWSTRESS(:, LL)=WEST_GWSTRESS(:, LL)+MIN(0.,RUWP(JW,:))/FLOAT(NW)
+       end DO
+    end DO
+
+    ! 5 CALCUL DES TENDANCES:
+
+    ! 5.1 Rectification des flux au sommet et dans les basses couches
+
+    RUW(:, KLEV + 1) = 0.
+    RVW(:, KLEV + 1) = 0.
+    RUW(:, 1) = RUW(:, LAUNCH)
+    RVW(:, 1) = RVW(:, LAUNCH)
+    DO LL = 1, LAUNCH
+       RUW(:, LL) = RUW(:, LAUNCH+1)
+       RVW(:, LL) = RVW(:, LAUNCH+1)
+       EAST_GWSTRESS(:, LL)=EAST_GWSTRESS(:, LAUNCH)
+       WEST_GWSTRESS(:, LL)=WEST_GWSTRESS(:, LAUNCH)
+    end DO
+
+    ! AR-1 RECURSIVE FORMULA (13) IN VERSION 4
+    DO LL = 1, KLEV
+       D_U(:, LL) = (1.-DTIME/DELTAT) * D_U(:, LL) + DTIME/DELTAT/REAL(NW) * &
+            RG * (RUW(:, LL + 1) - RUW(:, LL)) &
+            / (PH(:, LL + 1) - PH(:, LL)) * DTIME
+!  NO AR1 FOR MERIDIONAL TENDENCIES
+!      D_V(:, LL) = (1.-DTIME/DELTAT) * D_V(:, LL) + DTIME/DELTAT/REAL(NW) * &
+       D_V(:, LL) =                                            1./REAL(NW) * &
+            RG * (RVW(:, LL + 1) - RVW(:, LL)) &
+            / (PH(:, LL + 1) - PH(:, LL)) * DTIME
+    ENDDO
+
+    ! Cosmetic: evaluation of the cumulated stress
+    ZUSTR = 0.
+    ZVSTR = 0.
+    DO LL = 1, KLEV
+       ZUSTR = ZUSTR + D_U(:, LL) / RG * (PH(:, LL + 1) - PH(:, LL))/DTIME
+!      ZVSTR = ZVSTR + D_V(:, LL) / RG * (PH(:, LL + 1) - PH(:, LL))/DTIME
+    ENDDO
+! COSMETICS TO VISUALIZE ROTBA
+    ZVSTR = ROTBA
+
+  END SUBROUTINE ACAMA_GWD_RANDO
+
+end module ACAMA_GWD_rando_m
Index: /LMDZ5/branches/testing/libf/phylmd/add_pbl_tend.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/add_pbl_tend.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/add_pbl_tend.F90	(revision 2408)
@@ -15,13 +15,16 @@
   USE phys_local_var_mod
   USE phys_state_var_mod
+  USE mod_grid_phy_lmdz, ONLY: nbp_lev
   IMPLICIT NONE
-  include "dimensions.h"
-  REAL hthturb_gcssold(llm)
-  REAL hqturb_gcssold(llm)
-  REAL dtime_frcg
+  REAL,SAVE,ALLOCATABLE :: hthturb_gcssold(:)
+  REAL,SAVE,ALLOCATABLE :: hqturb_gcssold(:)
+!$OMP THREADPRIVATE(hthturb_gcssold,hqturb_gcssold)
+  REAL,SAVE :: dtime_frcg
+  LOGICAL,SAVE :: turb_fcg_gcssold
+  LOGICAL,SAVE :: firstcall=.true.
+!$OMP THREADPRIVATE(firstcall,turb_fcg_gcssold,dtime_frcg)
   INTEGER abortphy
-  LOGICAL turb_fcg_gcssold
-  COMMON /turb_forcing/dtime_frcg, hthturb_gcssold, hqturb_gcssold, &
-    turb_fcg_gcssold
+!  COMMON /turb_forcing/dtime_frcg, hthturb_gcssold, hqturb_gcssold, &
+!    turb_fcg_gcssold
 
   ! Arguments :
@@ -36,4 +39,10 @@
   REAL zzdt(klon, klev), zzdq(klon, klev)
   INTEGER i, k
+
+  IF (firstcall) THEN
+    ALLOCATE(hthturb_gcssold(nbp_lev))
+    ALLOCATE(hqturb_gcssold(nbp_lev))
+    firstcall=.false.
+  ENDIF
 
   IF (turb_fcg_gcssold) THEN
Index: /LMDZ5/branches/testing/libf/phylmd/add_phys_tend.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/add_phys_tend.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/add_phys_tend.F90	(revision 2408)
@@ -17,6 +17,6 @@
 use phys_local_var_mod
 use phys_state_var_mod
+use print_control_mod, only: prt_level
 IMPLICIT none
-  include "iniprint.h"
   include "YOMCST.h"
   include "clesphys.h"
Index: /LMDZ5/branches/testing/libf/phylmd/aero_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/aero_mod.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/aero_mod.F90	(revision 2408)
@@ -62,5 +62,19 @@
 
 ! 3/ Number of aerosol groups
-  INTEGER, PARAMETER :: naero_grp = 9 
+  INTEGER, PARAMETER :: naero_grp = 12
+  ! if info_trac = inca
+  ! 1 = ZERO    
+  ! 2 = AER total    
+  ! 3 = NAT    
+  ! 4 = BC    
+  ! 5 = SO4    
+  ! 6 = POM    
+  ! 7 = DUST    
+  ! 8 = SS    
+  ! 9 = FNO3    
+  ! 10 = DNO3
+  ! 11 = SNO3
+  ! 12 = empty actually 
+  ! else 
   ! 1 = ZERO    
   ! 2 = AER total    
Index: /LMDZ5/branches/testing/libf/phylmd/aeropt.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/aeropt.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/aeropt.F90	(revision 2408)
@@ -10,6 +10,4 @@
 
 
-  ! ym#include "dimensions.h"
-  ! ym#include "dimphy.h"
   include "YOMCST.h"
 
@@ -81,5 +79,5 @@
       IF (rh<0.) THEN
         abort_message = 'aeropt: RH < 0 not possible'
-        CALL abort_gcm(modname, abort_message, 1)
+        CALL abort_physic(modname, abort_message, 1)
       END IF
       IF (rh>85.) rh_num = 10
